package com.zyb.loveball;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.zyb.loveball.assets.Assets;

public class CircleLayer extends Actor {
    private NinePatch testPatch;
    private boolean start = false;
    float distance = 960;
    private float stateTime;
    private float outTime;
    private boolean hasShowFullADS = false;
    private int open =0;  //0 open 1 close
    LayerListener listener;

    public CircleLayer(float time) {
        this.outTime = time;
        setTouchable(Touchable.disabled);
        testPatch = new NinePatch(Assets.instance.ui.findRegion("circle_black"), 4, 4, 4, 4);
    }

    public void open(float x, float y) {
        testPatch.setLeftWidth(500);
        testPatch.setRightWidth(500);
        testPatch.setTopHeight(1200);
        testPatch.setBottomHeight(1200);
        testPatch.setMiddleHeight(15);
        testPatch.setMiddleWidth(15);
        open = 0;
        if (x > 480 || x < 0) {
            x = 240;
        }
        if (y < 0 || y > 800) {
            y = 400;
        }
        start = true;
        this.x = x;
        this.y = y;
        distance = Math.max(y, 960 - y);
        offset = 50/outTime * distance / 960;
    }

    public void setOutTime(float outTime) {
        this.outTime = outTime;
    }

    public void close(LayerListener listener){
        this.listener = listener;
        start = true;
        testPatch.setLeftWidth(10);
        testPatch.setRightWidth(10);
        testPatch.setTopHeight(10);
        testPatch.setBottomHeight(10);
        testPatch.setMiddleHeight(1200);
        testPatch.setMiddleWidth(1200);
        open = 1;
        this.x = 240;
        this.y = HelloZombieGame.getViewport().getWorldHeight()/2;
        distance = y;
        offset = 50/outTime * distance / 960;
    }

    private float offset = 40;

    @Override
    public void act(float delta) {
        super.act(delta);
        if(!start) return;
        stateTime += delta;
        float offsetDelta = offset*delta*60f;
        if(open==0){
            if (distance < -200 || stateTime > 5) {
                start = false;
                remove();
            //    showFullScreenAd(0);
            }
            if (start) {
                testPatch.setMiddleWidth(testPatch.getMiddleWidth() + offsetDelta);
                testPatch.setMiddleHeight(testPatch.getMiddleHeight() + offsetDelta);
                testPatch.setBottomHeight(testPatch.getBottomHeight() - offsetDelta / 2);
                testPatch.setTopHeight(testPatch.getTopHeight() - offsetDelta / 2);
                testPatch.setLeftWidth(testPatch.getLeftWidth() - offsetDelta / 2);
                testPatch.setRightWidth(testPatch.getRightWidth() - offsetDelta / 2);
                if(testPatch.getMiddleWidth()>200){
               //     showFullScreenAd(0);
                }
            }
            distance -= offset / 2;
            originX = testPatch.getTotalWidth() / 2;
            originY = testPatch.getTotalHeight() / 2;
        }else{
            if (start) {
                testPatch.setMiddleWidth(testPatch.getMiddleWidth() - offsetDelta);
                testPatch.setMiddleHeight(testPatch.getMiddleHeight() - offsetDelta);
                testPatch.setBottomHeight(testPatch.getBottomHeight() + offsetDelta / 2);
                testPatch.setTopHeight(testPatch.getTopHeight() + offsetDelta / 2);
                testPatch.setLeftWidth(testPatch.getLeftWidth() + offsetDelta / 2);
                testPatch.setRightWidth(testPatch.getRightWidth() + offsetDelta / 2);
//                if(testPatch.getMiddleWidth()<0){
//                    showFullScreenAd(0);
//                }
            }
            if (testPatch.getMiddleWidth()<0) {
                testPatch.setMiddleWidth(0);
                start = false;
//                showFullScreenAd(0);
                if(listener!=null){
                    listener.end();
                }
                //    remove();
            }
            distance += offset / 2;
            originX = testPatch.getTotalWidth() / 2;
            originY = testPatch.getTotalHeight() / 2;
        }


    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        batch.setColor(1, 1, 1, 1);
        testPatch.draw(batch, x - originX, y - originY, originX, originY, testPatch.getTotalWidth(), testPatch.getTotalHeight(), 1, 1, 0);
    }

    public interface LayerListener {
        public void end();
    }


}
