package com.zyb.loveball;

import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.assets.LevelData;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.objects.Pen;
import com.zyb.loveball.objects.Zombie;
import com.zyb.loveball.utils.FlurryUtils;

public class GameInfo {
    public static int id = -1;
    public static int chapter = -1;
    private static int chapterId;
    public static int levelId;
    public static int levelFileName;
    public static LevelData levelData;
    public static int life;
    public static boolean challenge;
    public static int star = 3;
    public static int failureTimes;
    public static boolean hint;
    public static boolean course;
    public static int oldStar;
    public static int type = 0;              //0为正常模式，1为happyGlass模式

    public static void init() {
        reset();
        id = Configuration.settingData.getLastLevelInt(0);
        chapter = Configuration.settingData.getLastChapterInt(0);
    }

    public static void reset(){
        failureTimes = 0;
        hint = false;
    }

    public static void challenge(int challengeId) {
        challenge = true;
        chapter = challengeId;
        id = 1;
        life = 5;
        Zombie.outDie = true;
        if (challengeId == 1) {
            Pen.PenConfig.ink_off_write = false;
        }else if(challengeId == 2){
            Zombie.outDie = false;
        }else if(challengeId == 3){
            Pen.PenConfig.ink_off_write = true;
            Pen.PenConfig.max_write_times = 1;
        }else if(challengeId == 4){
            GameScreen.gameType = GameScreen.GameType.HAPPY_GLASS;
        }
    }
    //0是一个球玩法，1是多个球玩法
    public static void normal(int type) {
        challenge = false;
        GameInfo.type = type;
        id = Configuration.settingData.getLastLevelInt(type);
        chapter = Configuration.settingData.getLastChapterInt(type);
        if(type == 0 && chapter>Constant.CHAPTER_NUN){
            chapter = Constant.CHAPTER_NUN;
            id = 10;
        }
        life = 1;
        Pen.PenConfig.ink_off_write = true;
        Pen.PenConfig.max_write_times = Integer.MAX_VALUE;
        Zombie.outDie = true;
        if(type == 0) {
            GameScreen.gameType = GameScreen.GameType.NORMAL;
        }else if(type == 1){
            GameScreen.gameType = GameScreen.GameType.HAPPY_GLASS;
        }
    }

    public static void start() {
        if(challenge) {
            chapterId = chapter + 10000;
        }else {
            chapterId = chapter;
        }
        if(chapter>1000){
            type = 1;
        }else {
            type = 0;
        }
        course = (GameInfo.chapterId == 1 && GameInfo.id == 1);
        levelId = Assets.instance.chaptersData.get(chapterId).getLevelId(id);
        levelData = Assets.instance.levelsData.get(levelId);
        levelFileName = getLevelFileName(chapterId,id);
        if (!challenge) {
            Configuration.settingData.setLastLevelInt(chapter,id,type);
        }
        oldStar = Configuration.settingData.getStars(chapter,id,type);
        star = 3;
        FlurryUtils.level_Start(chapter,id);
    }


    public static int getLevelFileName(int chapterId,int id){
        int levelId = Assets.instance.chaptersData.get(chapterId).getLevelId(id);
        LevelData levelData = Assets.instance.levelsData.get(levelId);
        int levelFileName = levelData.getFileName();
        return levelFileName;
    }


    public static void nextLevel(int type) {
        if(type == 0) {
            id++;
            if (id > 10) {
                id = 1;
                chapter++;
                if (chapter == Constant.CHAPTER_NUN + 1) {
                    chapter = 1;
                }
            }
        }else if(type == 1){
            id++;
            if (id > 10) {
                id = 1;
                chapter++;
                if (chapter == Constant.HAPPY_GLASS_CHAPTER_NUN + 1) {
                    chapter = 1;
                }

            }
        }
    }

    public static void preLevel(){
        id--;
        if (id < 1) {
            id = 10;
            chapter--;
            if (chapter <1) {
                chapter = 1;
            }
        }
    }

//    private static boolean isCourseLevel(){
//        if(challenge) return false;
//        boolean temp = false;
//        for(int i = 0; i <= Constant.hintLineHandArray.length-2; i += 2) {
//            if (GameInfo.chapter == Constant.hintLineHandArray[i]
//                    && GameInfo.id == Constant.hintLineHandArray[i + 1]) {
//                temp = true;
//            }
//        }
//        return temp;
//    }


}
