package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

/**
 * Created by Doodle on 2018/10/25.
 */

public class FlyZombieAnimation extends ZombieAnimation{
    @Override
    public void init() {
        super.init();
        MAtlasAttachmentLoader.prefix ="zombieFly_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
//        SkeletonData data = HelloZombieGame.getFlyData();
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/zombieFly.skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
        animationStateData.setMix("idle","fear",0.5f);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        skeleton.setSkin((type+1)+"");
        MAtlasAttachmentLoader.prefix="";
    }

    @Override
    public void idle() {
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(0, "idle", true);
    }

    @Override
    public void scared() {
        state.setTimeScale(1);
        rotationOffset = rotation;
//        state.setAnimation(0, "2", false);
        state.addAnimation(0, "fear", true, 0.2F);
    }

    @Override
    public void showBoomAnimation() {
        super.showBoomAnimation();
        zombieBoomAnimation = new CommonAnimation("animations/zombieBoom_animation_air.skel",1/160f,"baozha2");
        zombieBoomAnimation.getState().setAnimation(0,"die",false);
        zombieBoomAnimation.getSkeleton().setFlipX(skeleton.getFlipX());
    }
}
