package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.esotericsoftware.spine.AnimationState;
import com.esotericsoftware.spine.AnimationStateData;
import com.esotericsoftware.spine.Skeleton;
import com.esotericsoftware.spine.SkeletonBinary;
import com.esotericsoftware.spine.SkeletonData;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

/**
 * Created by Doodle on 2018/10/25.
 */

public class StandZombieAnimation extends ZombieAnimation{
    @Override
    public void init() {
        super.init();
        MAtlasAttachmentLoader.prefix = "zombie"+ type +"_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/zombie"+type+".skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
//        animationStateData.setMix("idle","fear",0.5f);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
//        xOffset = 0.08F;
        MAtlasAttachmentLoader.prefix = "";
    }

    @Override
    public void idle() {
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(0, "idle", true);
    }

    @Override
    public void scared() {
        state.setTimeScale(1);
        rotationOffset = rotation;
//        state.setAnimation(0, "2", false);
        state.setAnimation(0, "fear", true);
    }

    @Override
    public void smooth() {
        super.smooth();
        state.setAnimation(0, "smooth", true);
    }

    @Override
    public void showBoomAnimation() {
        super.showBoomAnimation();
        zombieBoomAnimation = new CommonAnimation("animations/zombieBoom_animation_ground.skel",1/80f,"baozha");
        zombieBoomAnimation.getState().setAnimation(0,"baozha",false);
        zombieBoomAnimation.getSkeleton().setFlipX(skeleton.getFlipX());
    }
}
