package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.esotericsoftware.spine.AnimationState;
import com.esotericsoftware.spine.Skeleton;
import com.esotericsoftware.spine.SkeletonRenderer;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.constants.Constant;

public class ZombieAnimation {
    protected Skeleton skeleton;
    protected AnimationState state;
    SkeletonRenderer renderer;
    float x, y, rotation;
    float rotationOffset = 0;
    float xOffset,yOffset;
    protected int type;
    CommonAnimation zombieBoomAnimation;
    boolean faceLeft = false;

    ZombieAnimationState zombieAnimationState = ZombieAnimationState.visible;


    public ZombieAnimation() {
        xOffset = 0;
//        yOffset = -0.255F;
        init();
    }

    public void init() {
        type = Configuration.settingData.getZombieId();
    }

    public void idle() {
    }

    public void faceLeft(boolean faceLeft) {
        this.faceLeft = faceLeft;
        skeleton.setFlipX(faceLeft);
        if(zombieBoomAnimation !=null){
            zombieBoomAnimation.getSkeleton().setFlipX(faceLeft);
        }
    }

    public void scared() {
    }
    public void smooth() {
    }

    public void boom(int ballId) {
        state.setTimeScale(1F);
        rotationOffset = rotation;
        if(ballId == Constant.BOMB_ID_1|| ballId == Constant.BOMB_ID_2){
            state.setAnimation(0, "die", false);
            showBoomAnimation();
        }else {
            zombieAnimationState = ZombieAnimationState.invisible;
        }
    }
    public void showBoomAnimation(){

    }

    public void happy(){
        state.setAnimation(0, "happy", false);
    }

    public void update(float x, float y,float rotation,float delta) {
        this.x = x;
        this.y = y;
        if (faceLeft) {
            this.rotation = -rotation;
        } else {
            this.rotation = +rotation;
        }
        state.update(delta);
        state.apply(skeleton);
        skeleton.setPosition(x+xOffset, y+yOffset);
        skeleton.getRootBone().setRotation(this.rotation);
        skeleton.updateWorldTransform();
        if(zombieBoomAnimation!=null){
            zombieBoomAnimation.setPosition(x,y);
            zombieBoomAnimation.setxOffset(xOffset);
            zombieBoomAnimation.setyOffset(yOffset);
            zombieBoomAnimation.act(Gdx.graphics.getDeltaTime());
        }
    }

    public void draw(Batch batch) {
        if(zombieAnimationState == ZombieAnimationState.visible){
            renderer.draw((PolygonSpriteBatch) batch, skeleton);
            if(zombieBoomAnimation!=null){
                zombieBoomAnimation.draw(batch,1);
            }
        }
    }
    enum ZombieAnimationState{
        visible,invisible
    }

    public void setRotation(float rotation) {
        this.rotation = rotation;
    }

    public void setOffset(float xOffset,float yOffset) {
        this.xOffset = xOffset;
        this.yOffset = yOffset;
    }
}
