package com.zyb.loveball.assets;

import com.badlogic.gdx.utils.Array;
import com.zyb.loveball.utils.Log;
import com.zyb.loveball.utils.MyRandom;


public class LevelData {
    private int id;
    private int fileName;
    private int reward;
    private boolean[] magnifier;
    private int inkAll;
    private int ink3;
    private int ink2;
    private int inkInitial;
    private int times;
    private int[] push =new int[11];
    private int hintPrice = 200;
    private boolean banner;
    private boolean showHint;
    private boolean rateLevel;
    private int pushType;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getFileName() {
        return fileName;
    }

    public void setFileName(int fileName) {
        this.fileName = fileName;
    }

    public int getReward() {
        return reward;
    }

    public void setReward(int reward) {
        this.reward = reward;
    }

    public boolean[] getMagnifier() {
        return magnifier;
    }

    public void setMagnifier(boolean[] magnifier) {
        this.magnifier = magnifier;
    }

    public int getInkAll() {
        return inkAll;
    }

    public void setInkAll(int inkAll) {
        this.inkAll = inkAll;
    }

    public int getInk3() {
        return ink3;
    }

    public void setInk3(int ink3) {
        this.ink3 = ink3;
    }

    public int getInk2() {
        return ink2;
    }

    public void setInk2(int ink2) {
        this.ink2 = ink2;
    }

    public int getInkInitial() {
        return inkInitial;
    }

    public int getTimes() {
        return times;
    }

    public void setInkInitial(int inkInitial) {
        this.inkInitial = inkInitial;
    }

    public void setTimes(int times) {
        this.times = times;
    }

    public void setPush(int id,int value){
        push[id] = value;
    }

    public Array<Integer> getCanPushIds(int idNum){
        Array<Integer> canPushIds = new Array<>();
        for(int i = 0;i<push.length;i++){
            if(push[i]!=0 && canPushIds.size<idNum){
                if(i == 6){
                    if(Configuration.checkLimitBallId() == -1){
                        canPushIds.add(7);
                        continue;
                    }
                }else if(i == 9){
                    if(Configuration.checkLimitPenId() == -1){
                        canPushIds.add(7);
                        continue;
                    }
                }else if(i == 10){
                    if(Configuration.checkLimitZombieId() == -1){
                        canPushIds.add(7);
                        continue;
                    }
                }
                canPushIds.add(i);
            }
        }
        for(int i = canPushIds.size;i<idNum;i++){
            canPushIds.add(7);
        }
        return canPushIds;
    }


    public int getPushId(){
        boolean coinEnough = false;
        boolean hasLimitBall = false;
        boolean hasLimitPen = false;
        boolean hasLimitZombie = false;
        if(Configuration.checkDiscountBallId(0.85F) !=-1){
            coinEnough = true;
        }
        if(Configuration.checkLimitBallId() != -1){
            hasLimitBall = true;
        }
        if(Configuration.checkLimitPenId() != -1){
            hasLimitPen = true;
        }
        if(Configuration.checkLimitZombieId() != -1){
            hasLimitZombie = true;
        }
        Log.log("SuccessDialog", "extraReward()----> coinEnough " + coinEnough);
        int total = 0;
        int id = 0;
        for(int i = 0;i<push.length;i++){
//            if(!coinEnough && (i == 4 || i ==5)) continue;
//            if(!hasLimitBall && i == 6) continue;
//            if(!hasLimitPen && i == 9) continue;
//            if(!hasLimitZombie && i == 10) continue;
            total+=push[i];
        }
        if(total == 0) id = 0;
        else {
            int randomValue = MyRandom.getInstance().nextInt(total);
            int temp = 0;
            for (int i = 0; i < push.length; i++) {
//                if(!coinEnough && (i == 4 || i == 5)) continue;
//                if(!hasLimitBall && i == 6) continue;
//                if(!hasLimitPen && i == 9) continue;
//                if(!hasLimitZombie && i == 10) continue;
                temp += push[i];
                if (randomValue <= temp) {
                    id = i;
                    if(!hasLimitBall && id == 6) id = 7;
                    else if(!hasLimitPen && id == 9) id = 7;
                    else if(!hasLimitZombie && id == 10) id = 7;
                    else if(!coinEnough && (id == 4 || id == 5)) id = 7;
                    break;
                }
            }
            Log.log("LevelData","level id : + " + this.id +  "    extra reward :" + id + "   total: " + total + "   randomValue: " + randomValue);
        }
        return id;
    }

    public void setShowHint(boolean showHint) {
        this.showHint = showHint;
    }

    public boolean isShowHint() {
        return showHint;
    }

    public void setBanner(boolean banner) {
        this.banner = banner;
    }

    public boolean isBanner() {
        return banner;
    }

    public int getHintPrice() {
        return hintPrice;
    }

    public boolean isRateLevel() {
        return rateLevel;
    }

    public void setRateLevel(boolean rateLevel) {
        this.rateLevel = rateLevel;
    }

    public void setHintPrice(int hintPrice) {
        this.hintPrice = hintPrice;
    }

    public int getPushType() {
        return pushType;
    }

    public void setPushType(int pushType) {
        this.pushType = pushType;
    }
}
