package com.zyb.loveball.assets;

import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.utils.FlurryUtils;
import com.zyb.loveball.utils.Log;

public class SettingData {
    private int stars[][] = new int[50][];
    private int happyGlassStars[][] = new int[50][];
    private boolean[] useHint = new boolean[500];
    private boolean[] happyGlassUseHint = new boolean[500];
    private boolean[] ChallengeUseHint = new boolean[500];
    private int coin = 0;
    private int penId = 1;
    private int ballId = 1;
    private int zombieId = 1;
    private boolean[] pens = new boolean[12];
    private boolean[] balls = new boolean[20];
    private boolean[] zombies = new boolean[20];
    private long[] ballDeadline = new long[20];
    private long[] penDeadline = new long[20];
    private long[] zombieDeadline = new long[20];
    private boolean[] challenge = new boolean[20];
    private boolean sound;
    private boolean music;
    private boolean notification;
    private int lastLevelInt;
    private int lastChapterInt;
    private int lastHappyGlassLevelInt = 1;
    private int lastHappyGlassChapterInt = 1001;
    private int unlockChapter;
    private int unlockLevel;
    private boolean[][] levels = new boolean[50][11];
    private boolean[][] happyGlassLevels = new boolean[50][11];
    private int versionCode = 1;
    private boolean firstPlay =true;
    private boolean rate = false;
    private long game_time = -1;
    private long install_time = -1;
    private boolean rateShow[] = new boolean[10];
    private int effectiveBootTimesPerDay;
    private int[] hardLevel3StarNoHint  = new int[10];
    private boolean inkProgressCourse = false;
    private boolean hintCourse = false;
    private boolean retryCourse = false;
    private boolean netCourse = false;
    private boolean firstWatchVideo = true;


    public SettingData() {
        initInt(stars, 31, 0);
        initInt(happyGlassStars, 31, 0);
        stars[1][1] = 0;
        pens[0] = true;
        balls[0] = true;
        zombies[0] = true;
        sound = true;
        music = true;
        notification = true;
        coin = 0;
        lastLevelInt = 1;
        lastChapterInt = 1;
        lastHappyGlassChapterInt = 1001;
        lastHappyGlassLevelInt = 1;
        unlockChapter = 1;
        unlockLevel = 1;
        game_time = System.currentTimeMillis();
        install_time = game_time;
        levels[1][1] = true;
        happyGlassLevels[1][1] = true;
    }

    private void initInt(int[][] temp, int size, int defaultValue) {
        for (int i = 0; i < temp.length; i++) {
            temp[i] = new int[size];
            for (int j = 0; j < temp[i].length; j++) {
                temp[i][j] = defaultValue;
            }
        }
    }

    private void initFloat(float[] temp,float defaultValue){
        for (int i = 0;i<temp.length;i++){
            temp[i] = defaultValue;
        }
    }

    public void unlockNextLevel(int chapter,int level,int type) {
        if(type == 0) {
            level++;
            if (level > 10) {
                level = 1;
                chapter++;
                if (chapter > Constant.CHAPTER_NUN) {
                    chapter = Constant.CHAPTER_NUN;
                }
            }
            levels[chapter][level] = true;
        }else if(type == 1){
            int chapterSub = chapter-1000;
            level++;
            if (level > 10) {
                level = 1;
                chapterSub++;
                if (chapterSub > Constant.HAPPY_GLASS_CHAPTER_NUN) {
                    chapterSub = Constant.HAPPY_GLASS_CHAPTER_NUN;
                }
            }
            happyGlassLevels[chapterSub][level] = true;
        }
    }

    public void unlockLevel(int chapter,int level,int type){
        if(type == 0) {
            if (chapter <= Constant.CHAPTER_NUN && level <= 10) {
                if (levels == null) {
                    levels = new boolean[50][11];
                }
                levels[chapter][level] = true;
            }
        }else if(type == 1){
            int chapterSub = chapter-1000;
            if (chapterSub <= Constant.HAPPY_GLASS_CHAPTER_NUN && level <= 10) {
                if (happyGlassLevels == null) {
                    happyGlassLevels = new boolean[50][11];
                }
                happyGlassLevels[chapterSub][level] = true;
            }
        }
    }

    public boolean isInkProgressCourse() {
        return inkProgressCourse;
    }

    public void setInkProgressCourse(boolean inkProgressCourse) {
        this.inkProgressCourse = inkProgressCourse;
    }

    public boolean isHintCourse() {
        return hintCourse;
    }

    public void setHintCourse(boolean hintCourse) {
        this.hintCourse = hintCourse;
    }

    public boolean isRetryCourse() {
        return retryCourse;
    }

    public void setRetryCourse(boolean retryCourse) {
        this.retryCourse = retryCourse;
    }

    public boolean isNetCourse() {
        return netCourse;
    }

    public void setNetCourse(boolean netCourse) {
        this.netCourse = netCourse;
    }

    public boolean isRate() {
        return rate;
    }

    public void setRate(boolean rate) {
        this.rate = rate;
    }

    public int getUnlockChapter() {
        return unlockChapter;
    }

    public boolean isLevelUnLocked(int chapter,int level,int type){
        if(Configuration.unlock) return true;
        if(type == 0) {
            return levels[chapter][level];
        }else if(type == 1){
//            int chapterSub = chapter-1000;
//            return happyGlassLevels[chapterSub][level];
            return true;
        }
        return false;
    }

    public boolean isChapterUnLocked(int chapter){
        if(Configuration.unlock) return true;
        if(chapter == 1) return true;
        else{
            chapter --;
            if(stars[chapter][10]>0){
                return true;
            }else{
                return false;
            }
        }
    }

    public boolean isBaseLevelAllPassed(){
        boolean flag = true;
        for(int i = 1;i<=3;i++){
            if(stars[1][i] == 0){
                flag = false;
                break;
            }
        }
        return flag;
    }

    public int getUnlockLevel() {
        return unlockLevel;
    }

    public int getLastLevelInt(int type) {
        if(type == 0) {
            return lastLevelInt;
        }else if(type == 1){
            return lastHappyGlassLevelInt;
        }
        return -1;
    }

    public int getLastChapterInt(int type) {
        if(type == 0) {
            return lastChapterInt;
        }else if(type == 1){
            return lastHappyGlassChapterInt;
        }
        return -1;
    }

    public void setLastLevelInt(int lastChapter,int lastLevelInt,int type) {
        if(type == 0) {
            this.lastChapterInt = lastChapter;
            this.lastLevelInt = lastLevelInt;
        }else if(type == 1){
            this.lastHappyGlassChapterInt = lastChapter;
            this.lastHappyGlassLevelInt = lastLevelInt;
        }
    }
    public void setSound(boolean sound) {
        this.sound = sound;
    }

    public void setMusic(boolean music) {
        this.music = music;
    }

    public boolean isMusic() {
        return music;
    }

    public boolean isSound() {
        return sound;
    }

    public boolean isNotification() {
        return notification;
    }

    public void setNotification(boolean notification) {
        this.notification = notification;
    }


    public int getPenId() {
        return penId;
    }

    public int getBallId() {
        return ballId;
    }

    public int getZombieId() {
        return zombieId;
    }

    public boolean isGoodUnlocked(int id, int type) {
        if (id < 1) {
            Log.log("SettingData", "get good state error,id can't <1, id = " + id + " type = " + type);
            return false;
        }
        try {
            if (type == 0) {
                return pens[id - 1];
            } else if(type == 1){
                return balls[id - 1];
            } else{
                return zombies[id - 1];
            }
        } catch (ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
            if (type == 0) {
                pens = resizeBoolean(pens);
            } else if(type == 1){
                balls = resizeBoolean(balls);
            } else if(type == 2){
                zombies = resizeBoolean(zombies);
            }
            return isGoodUnlocked(id, type);
        }

    }

    private boolean [] resizeBoolean(boolean[] value){
        int length = Math.round(value.length*1.5F);
        boolean[] temp = new boolean[length];
        for(int i = 0;i<value.length;i++){
            temp[i] = value[i];
        }
        return temp;
    }

    private boolean [] resizeBoolean(boolean[] value,int minLength){
        int length = Math.max(minLength,Math.round(value.length*1.5F));
        boolean[] temp = new boolean[length];
        for(int i = 0;i<value.length;i++){
            temp[i] = value[i];
        }
        return temp;
    }

    public int getGoodId(int type) {
        if (type == 0) return penId;
        else if(type == 1)return ballId;
        else return zombieId;
    }

    public void setGoodId(int id, int type) {
        if (type == 0) {
            penId = id;
            FlurryUtils.Skin_Pen(id);
        }
        else if(type == 1){
            ballId = id;
            FlurryUtils.Skin_Bomb(id);
        }else {
            zombieId = id;
            FlurryUtils.Skin_Zombie(id);
        }
    }

    public void setPenId(int penId) {
        this.penId = penId;
    }

    public void setBallId(int ballId) {
        this.ballId = ballId;
    }


    public void setZombieId(int zombieId) {
        this.zombieId = zombieId;
    }


    public int getStars(int chapter, int level,int type) {
        if(type == 0) {
            if (level >= stars[chapter].length) {
                int temp[] = new int[level + 10];
                for (int i = 0; i < stars[chapter].length; i++) {
                    temp[i] = stars[chapter][i];
                }
                stars[chapter] = temp;

            }
            return stars[chapter][level];
        }else {
            int chapterSub = chapter-1000;
            if (level >= happyGlassStars[chapterSub].length) {
                int temp[] = new int[level + 10];
                for (int i = 0; i < happyGlassStars[chapterSub].length; i++) {
                    temp[i] = happyGlassStars[chapterSub][i];
                }
                happyGlassStars[chapterSub] = temp;
            }
            return happyGlassStars[chapterSub][level];
        }
    }

    public int getStarTotal() {
        int total = 0;
        for(int i = 0;i<=Constant.CHAPTER_NUN;i++) {
            for (int j = 0; j < stars[i].length; j++) {
                total += stars[i][j];
            }
        }
        for(int i = 0;i<=Constant.HAPPY_GLASS_CHAPTER_NUN;i++){
            for (int j = 0; j < happyGlassStars[i].length; j++) {
                total += happyGlassStars[i][j];
            }
        }
        return total;
    }

    public int getStarsChapter(int chapter) {
        int total = 0;
        for (int j = 0; j < stars[chapter].length; j++) {
            total += stars[chapter][j];
        }
        return total;
    }

    public void setStar(int chapter, int level, int value,int type) {
        if(type == 0) {
            if (value > stars[chapter][level]) {
                stars[chapter][level] = value;
            }
        }else if(type == 1){
            int chapterSub = chapter-1000;
            if (value > happyGlassStars[chapterSub][level]) {
                happyGlassStars[chapterSub][level] = value;
            }
        }
    }


    public boolean cost(int cost) {
        if (coin >= cost) {
            coin -= cost;
            Configuration.saveData();
            return true;
        }
        return false;
    }

    public boolean isChallengePassed(int id){
        return challenge[id-1];
    }

    public void challengePass(int id){
        challenge[id-1] = true;
    }

    public void unlockGood(int id, int type) {
        if (id < 1) {
            Log.log("SettingData", "get good state error,id can't <1, id = " + id + " type = " + type);
        }
        if (type == 0) {
            pens[id - 1] = true;
        } else if(type == 1){
            balls[id - 1] = true;
        } else if(type == 2){
            zombies[id - 1] = true;
        }
        setGoodId(id, type);
        Configuration.saveData();
    }

    public int getCoin() {
        if(coin>9999999){
            return 9999999;
        }
        return coin;
    }

    public void setBallDeadline(int id){
        ballDeadline[id] = System.currentTimeMillis()+24*60*60*1000;
    }
    public long getBallDeadlineTime(int id){
        return ballDeadline[id];
    }

    public void setPenDeadline(int id){
        penDeadline[id] = System.currentTimeMillis()+24*60*60*1000;
    }
    public long getPenDeadlineTime(int id){
        return penDeadline[id];
    }
    public void setZombieDeadline(int id){
        zombieDeadline[id] = System.currentTimeMillis()+24*60*60*1000;
    }
    public long getZombieDeadlineTime(int id){
        return zombieDeadline[id];
    }


    public void addCoin(int offset) {
        if (offset > 0) {
            coin += offset;
            Configuration.saveData();
        }
    }

    public void rateShow(int index){
        rateShow[index] = true;
    }

    public boolean isRateShow(int index){
        return rateShow[index];
    }

    public long getInstall_time() {
        return install_time;
    }

    public void setInstall_time(long install_time) {
        this.install_time = install_time;
    }

    public long getGame_time() {
        return game_time;
    }

    public void setGame_time(long game_time) {
        this.game_time = game_time;
    }

    public void addEffectiveBootTimesPerDay() {
        effectiveBootTimesPerDay++;
    }

    public int getEffectiveBootTimesPerDay() {
        return effectiveBootTimesPerDay;
    }

    public void resetEffectiveBootTimesPerDay(){
        effectiveBootTimesPerDay = 0;
    }

    public boolean isUseHint(int levelId) {
        return useHint[levelId];
    }

    public void setUseHint(int levelId,boolean value) {
        if(levelId>=useHint.length && levelId<=1000){
            useHint = resizeBoolean(useHint,levelId+1);
        }
        if(levelId<=1000) {
            useHint[levelId] = value;
        }
    }



    public void setHardLevel3StarNoHint(int levelId){
        boolean alreadyIn = false;
        int position = -1;
        for(int i = 0;i<hardLevel3StarNoHint.length;i++){
            if(levelId == hardLevel3StarNoHint[i]){
                alreadyIn = true;
            }
            if(hardLevel3StarNoHint[i] == 0){
                position = i;
                break;
            }
        }
        if(alreadyIn) return;
        else{
            if(position == -1){
                position = hardLevel3StarNoHint.length;
                int[] temp = new int[hardLevel3StarNoHint.length*2];
                for(int i = 0;i<hardLevel3StarNoHint.length;i++){
                    temp[i] = hardLevel3StarNoHint[i];
                }
                hardLevel3StarNoHint = temp;
            }
            hardLevel3StarNoHint[position] = levelId;
        }
    }

    public int getHardLevelPassNum(){
        int position = -1;
        for(int i = 0;i<hardLevel3StarNoHint.length;i++){
            if(hardLevel3StarNoHint[i] == 0){
                position = i;
                break;
            }
        }
        return position;
    }

    public void setVersionCode(int versionCode) {
        this.versionCode = versionCode;
    }

    public int getVersionCode() {
        return versionCode;
    }

    public void setFirstPlay(boolean firstPlay) {
        this.firstPlay = firstPlay;
    }

    public boolean isFirstPlay() {
        return firstPlay;
    }

    @Override
    public String toString() {
        try {
            return HelloZombieGame.getJson().toJson(this);
        }catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }

    public int[][] getStars() {
        return stars;
    }

    public void setStars(int[][] stars) {
        this.stars = stars;
    }

    public boolean[] getUseHint() {
        return useHint;
    }

    public void setUseHint(boolean[] useHint) {
        this.useHint = useHint;
    }

    public void setCoin(int coin) {
        this.coin = coin;
    }

    public boolean[] getPens() {
        return pens;
    }

    public void setPens(boolean[] pens) {
        this.pens = pens;
    }

    public boolean[] getBalls() {
        return balls;
    }

    public void setBalls(boolean[] balls) {
        this.balls = balls;
    }

    public long[] getBallDeadline() {
        return ballDeadline;
    }

    public void setBallDeadline(long[] ballDeadline) {
        this.ballDeadline = ballDeadline;
    }

    public boolean[] getChallenge() {
        return challenge;
    }

    public void setChallenge(boolean[] challenge) {
        this.challenge = challenge;
    }

    public void setLastLevelInt(int lastLevelInt) {
        this.lastLevelInt = lastLevelInt;
    }

    public void setLastChapterInt(int lastChapterInt) {
        this.lastChapterInt = lastChapterInt;
    }

    public void setUnlockChapter(int unlockChapter) {
        this.unlockChapter = unlockChapter;
    }

    public void setUnlockLevel(int unlockLevel) {
        this.unlockLevel = unlockLevel;
    }

    public boolean[][] getLevels() {
        return levels;
    }

    public void setLevels(boolean[][] levels) {
        this.levels = levels;
    }

    public boolean[] getRateShow() {
        return rateShow;
    }

    public void setRateShow(boolean[] rateShow) {
        this.rateShow = rateShow;
    }

    public void setEffectiveBootTimesPerDay(int effectiveBootTimesPerDay) {
        this.effectiveBootTimesPerDay = effectiveBootTimesPerDay;
    }

    public int[] getHardLevel3StarNoHint() {
        return hardLevel3StarNoHint;
    }

    public void setHardLevel3StarNoHint(int[] hardLevel3StarNoHint) {
        this.hardLevel3StarNoHint = hardLevel3StarNoHint;
    }

    public boolean isFirstWatchVideo() {
        return firstWatchVideo;
    }

    public void setFirstWatchVideo(boolean firstWatchVideo) {
        this.firstWatchVideo = firstWatchVideo;
    }
}
