package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2019/4/19.
 */

public class ChallengeConfirmDialog extends BaseDialog{
    ChallengeConfirmDialogListener challengeConfirmDialogListener;
    Label titleLabel;
    Label contentLabel;
    @Override
    public void show(Group parent) {
        super.show(parent);
        titleLabel = group.findActor("font_title");
        contentLabel = group.findActor("font_text");
        contentLabel.setAlignment(Align.center);
        float ff=contentLabel.getX(Align.center);
        contentLabel.setWidth(360);
        contentLabel.setX(ff,Align.center);
        contentLabel.setWrap(true);
    }

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_yes",Touchable.enabled).addListener(new SoundButtonListener(){
            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                if(challengeConfirmDialogListener!=null){
                    challengeConfirmDialogListener.jumpToChallengeLevelScreen();
                }
            }
        });
        group.findActor("btn_no",Touchable.enabled).addListener(new SoundButtonListener(){
            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                close();
            }
        });
    }

    public void setChallengeConfirmDialogListener(ChallengeConfirmDialogListener challengeConfirmDialogListener) {
        this.challengeConfirmDialogListener = challengeConfirmDialogListener;
    }

    public interface ChallengeConfirmDialogListener{
        public void jumpToChallengeLevelScreen();
    }
}
