package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2019/3/22.
 */

public class HintConfirmDialog extends  BaseDialog{
    HintConfirmDialogListener hintConfirmDialogListener;
    @Override
    public void show(Group parent) {
        super.show(parent);
    }


    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_yes", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                if(hintConfirmDialogListener!=null){
                    close();
                    hintConfirmDialogListener.playVideoAds();
                }
            }
        });
        group.findActor("btn_no", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                    close();
            }
        });
    }
    @Override
    public void update() {
        super.update();
        if(Configuration.videoAdReady){
            group.findActor("btn_yes").setTouchable(Touchable.enabled);
            group.findActor("btn_gray").setVisible(false);
        }else{
            group.findActor("btn_yes").setTouchable(Touchable.disabled);
            group.findActor("btn_gray").setVisible(true);
        }
    }
    public void setHintConfirmDialogListener(HintConfirmDialogListener hintConfirmDialogListener) {
        this.hintConfirmDialogListener = hintConfirmDialogListener;
    }
    public interface HintConfirmDialogListener{
        public void playVideoAds();
    }
}
