package com.zyb.loveball.dialogs;

import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.SpriteDrawable;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.assets.GoodData;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/9/17.
 */

public class LimitGoodsDialog extends BaseDialog {
    int unlockId;
    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_ok", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
            }
        });
        group.findActor("btn_use", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
                if(unlockId<=100){
                    Configuration.settingData.setPenId(unlockId);
                }else if(unlockId>100&&unlockId<=1000){
                    Configuration.settingData.setBallId(unlockId-100);
                }else {
                    Configuration.settingData.setZombieId(unlockId-1000);
                }
            }
        });
    }

    public void setData(int id){
        unlockId = id;
        Image image = group.findActor("skin_mask");
        GoodData goodData = null;
        Sprite sprite = null;
        if(id<=100) {
            goodData = Assets.instance.getGoodData(id, 0);
            sprite = Assets.instance.ui.createSprite(goodData.getResources()+"_icon");
        }else if(id>100&&id<=1000){
            goodData = Assets.instance.getGoodData(id-100, 1);
            sprite = Assets.instance.ui.createSprite(goodData.getResources());
        }else {
            goodData = Assets.instance.getGoodData(id-1000, 2);
            sprite = Assets.instance.ui.createSprite(goodData.getResources()+"_icon");
        }
        SpriteDrawable spriteDrawable = new SpriteDrawable(sprite);
        image.setDrawable(spriteDrawable);
    }

    @Override
    public void update() {
        super.update();
    }

    public interface UnlockBallDialogListener{
        public void success();
    }
}
