package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.utils.Array;
import com.esotericsoftware.spine.AnimationState;
import com.zyb.loveball.GameInfo;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.animations.CommonAnimation;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.screens.BaseScreen;
import com.zyb.loveball.utils.Log;

/**
 * Created by Doodle on 2019/1/28.
 */

public class SuccessBonusBaseDialog extends BaseDialog{
    public successBonusBaseDialogListener successBonusBaseDialogListener;
    Array<Integer> showRewardInt;
    int reward;
    protected int[] coinValue = Constant.rewardNum;
    int limitGoodsPenId;
    int limitGoodsBallId;
    int limitGoodsZombieId;

    @Override
    public void load(Group group) {
        super.load(group);
        if(this instanceof SuccessBonusTurntableDialog) {
            showRewardInt = GameInfo.levelData.getCanPushIds(6);
        }else {
            showRewardInt = GameInfo.levelData.getCanPushIds(4);
        }
    }

    @Override
    public void show(Group parent) {
        super.show(parent);
        coinLabel.setText(Configuration.numType.format(Configuration.settingData.getCoin()));
        group.setPosition(0, (HelloZombieGame.getViewport().getWorldHeight() - 800) / 2);
    }

    public void init(){
        layer.clearListeners();
    }

    //type == -1 , 球，笔，僵尸获得一个id
    protected void initLimitGoods(int type){
        if(type == 0){
            limitGoodsPenId = Configuration.checkLimitPenId();
        }else if(type == 1){
            limitGoodsBallId = Configuration.checkLimitBallId();
        }else if(type == 2){
            limitGoodsZombieId = Configuration.checkLimitZombieId();
        }else {
            limitGoodsPenId = Configuration.checkLimitPenId();
            limitGoodsBallId = Configuration.checkLimitBallId();
            limitGoodsZombieId = Configuration.checkLimitZombieId();
        }
    }

    protected void reward(boolean showAnimation){
        Log.log("SuccessBonusBaseDialog", "reward()----> reward " + reward);
        Log.log("SuccessBonusBaseDialog", "reward()----> showRewardInt " + showRewardInt);
        switch (reward){
            case 1:
//                successBonusBaseDialogListener.coinGot(10*coinValue);
                addCoin(coinValue[1],showAnimation);
                break;
            case 2:
//                successBonusBaseDialogListener.coinGot(8*coinValue);
                addCoin(coinValue[2],showAnimation);
                break;
            case 3:
//                successBonusBaseDialogListener.coinGot(5*coinValue);
                addCoin(coinValue[3],showAnimation);
                break;
            case 4:
                //85pifu
                break;
            case 5:
                //75pifu
                break;
            case 6:
                successBonusBaseDialogListener.limitGoodsGot(limitGoodsBallId);
                initLimitGoods(1);
                break;
            case 7:
//                successBonusBaseDialogListener.coinGot(3*coinValue);
                addCoin(coinValue[7],showAnimation);
                break;
            case 8:
//                successBonusBaseDialogListener.coinGot(6*coinValue);
                addCoin(coinValue[8],showAnimation);
                break;
            case 9:
                //xianshibi
                successBonusBaseDialogListener.limitGoodsGot(limitGoodsPenId);
                initLimitGoods(0);
                break;
            case 10:
                //xianshipifu
                successBonusBaseDialogListener.limitGoodsGot(limitGoodsZombieId);
                initLimitGoods(2);
                break;
        }
//        Configuration.settingData.setBallDeadline(pendingValue);
//        LimitGoodsDialog dialog = (LimitGoodsDialog) showDialog("ui/dialogs/banner_unlock_time_limited_skin.json",LimitGoodsDialog.class);
    }

    protected void addCoin(int coinValue,boolean showAnimation){
        if(showAnimation) {
            CommonAnimation commonAnimation = successBonusBaseDialogListener.coinGot(coinValue);
            commonAnimation.getState().addListener(new AnimationState.AnimationStateAdapter() {
                @Override
                public void complete(AnimationState.TrackEntry entry) {
                    super.complete(entry);
                    updateCoin();
                }
            });
        }else {
            Configuration.settingData.addCoin(coinValue);
        }
    }
    protected void updateCoin(){
        coinLabel.setText(Configuration.numType.format(Configuration.settingData.getCoin()));
    }

    public void begin(){
        reward = GameInfo.levelData.getPushId();
        Log.log("SuccessBonusBaseDialog", "begin()----> reward " + reward);
    }


    @Override
    protected void initButtons() {
        super.initButtons();
    }

    @Override
    public void close() {
        super.close();
        if(successBonusBaseDialogListener != null) {
            successBonusBaseDialogListener.showSuccessDialog();
        }
    }


    public void setSuccessBonusBaseDialogListener(successBonusBaseDialogListener successBonusBaseDialogListener){
        this.successBonusBaseDialogListener = successBonusBaseDialogListener;
    }
    public interface successBonusBaseDialogListener {
        public void showSuccessDialog();
        public void next();
        public CommonAnimation coinGot(int coin);
        public void limitGoodsGot(int id);
        public void playVideo(BaseScreen.PendingAction action, int pendingValue);
    }
}
