package com.zyb.loveball.dialogs;

import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.SpriteDrawable;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.assets.GoodData;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/9/17.
 */

public class UnlockBallDialog extends BaseDialog {
    UnlockBallDialogListener unlockBallDialogListener;
    int unlockId;
    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_ok", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
            }
        });
        group.findActor("btn_use", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
                Configuration.settingData.setBallId(unlockId);
            }
        });
    }

    public void setData(int id){
        unlockId = id;
        int oldBallId = Configuration.settingData.getBallId();
        Configuration.settingData.unlockGood(id,1);
        Configuration.settingData.setBallId(oldBallId);
        Image image = group.findActor("skin_mask");
        GoodData goodData = Assets.instance.getGoodData(id,1);
        Sprite sprite = Assets.instance.ui.createSprite(goodData.getResources());
        SpriteDrawable spriteDrawable = new SpriteDrawable(sprite);
        image.setDrawable(spriteDrawable);
        Label label = group.findActor("star_label");
        label.setAlignment(Align.center);
        float ff=label.getX(Align.center);
        label.setWidth(360);
        label.setX(ff,Align.center);
        label.setWrap(true);
        if(goodData.getCondition() == 1) {
            label.setText("Reached " + goodData.getCoin() + " stars and unlock new skin!");
        }else{
            label.setText("Getting new skin!");
        }
    }

    @Override
    public void close() {
        super.close();
        if(unlockBallDialogListener!=null){
            unlockBallDialogListener.success();
        }
    }

    @Override
    public void update() {
        super.update();
    }

    public void setUnlockBallDialogListener(UnlockBallDialogListener unlockBallDialogListener) {
        this.unlockBallDialogListener = unlockBallDialogListener;
    }

    public interface UnlockBallDialogListener{
        public void success();
    }
}
