package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2019/1/4.
 */

public class UnlockLevelDialog extends BaseDialog {
    UnlockLevelDialogListener unlockLevelDialogListener;
    public static int chapter;
    public static int level;
    @Override
    public void show(Group parent) {
        super.show(parent);
    }

    public void setLevel(int chapter,int level) {
        ((Label)group.findActor("title_font")).setText("Level "+chapter+"-"+level+" Locked");
        UnlockLevelDialog.chapter = chapter;
        UnlockLevelDialog.level = level;
    }

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_yes", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                if(unlockLevelDialogListener!=null){
                    close();
                    unlockLevelDialogListener.playVideoAds();
                }
            }
        });
    }
    @Override
    public void update() {
        super.update();
        if(Configuration.videoAdReady){
            group.findActor("btn_yes").setTouchable(Touchable.enabled);
            group.findActor("btn_gray").setVisible(false);
        }else{
            group.findActor("btn_yes").setTouchable(Touchable.disabled);
            group.findActor("btn_gray").setVisible(true);
        }
    }
    public void setUnlockLevelDialogListener(UnlockLevelDialogListener unlockLevelDialogListener) {
        this.unlockLevelDialogListener = unlockLevelDialogListener;
    }
    public interface UnlockLevelDialogListener{
        public void playVideoAds();
    }
}
