package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.Camera;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.utils.LayerUtils;

public class GameBg {
    NinePatch bg;
    TextureRegion gridRegion;
    private boolean drawable = true;
    float cameraZoom;
    float bgWidth = 580;
    float bgHeight = 1200;
    float bgX = 0;
    float bgY = 0;
    float bgOffsetX = -0.625f;
    float bgOffsetY = -1f;

    public GameBg(OrthographicCamera camera){
        cameraZoom = camera.zoom;
        bgOffsetX *= cameraZoom;
        bgOffsetY *= cameraZoom;
        bgX = 3-cameraZoom*3;
        bgY = 5-cameraZoom*5-(cameraZoom-1)*(camera.viewportHeight-10)/2;
        bgWidth *= cameraZoom;
        bgHeight *= cameraZoom;
        bg = LayerUtils.createLayerNinePatch(0.6F);
        bg.setColor(new Color(249/255f,250/255f,232/255f,1));
        gridRegion = Assets.instance.ui.findRegion("bg_net");
    }

    public void setDrawable(boolean drawable) {
        this.drawable = drawable;
    }

    public void draw(Batch batch, float parentAlpha) {
        if(!drawable) return;
        batch.setColor(1,1,1,1);
        bg.draw(batch,bgX+bgOffsetX,bgY+bgOffsetY,0,0,bgWidth,bgHeight,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,0,0,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,0,10,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,6,0,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,6,10,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,0,20,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
//        batch.draw(gridRegion,6,20,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
        for(int i = 0;i<=cameraZoom;i++){
            for(int j = 0;j<cameraZoom;j++){
                batch.draw(gridRegion,bgX+6*j,bgY+10*i,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
            }
        }
    }

}
